%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_MPC_Delete(MPC_list)

global ErrCode;

global DB_MPC;
global AST_NODES;

global AT_MPC;
global AT_NODES;

MPC_list = unique(MPC_list);

% Проверка существования в базе MPC
for i=1:size(MPC_list,1)
    if (~DB_MPC_Exist(MPC_list(i)))
        fprintf (1, '\nОшибка функции DB_MPC_Delete: MPC с номером %i отсутствует в базе !\n', MPC_list(i));
        ErrCode = -1;
        return;
    end
end

% Внесение изменений в таблицу ассоциативности узлов

for i=1:size(MPC_list,1)

    switch DB_MPC{AT_MPC(MPC_list(i))}.type

        case {'RBAR', 'RBE2'}
            Remove_Nodes_list = Union_Column(DB_MPC{AT_MPC(MPC_list(i))}.ind_grid, DB_MPC{AT_MPC(MPC_list(i))}.dep_grid);

        case 'RBE3'
            Remove_Nodes_list = Union_Column(DB_MPC{AT_MPC(MPC_list(i))}.dep_grid, DB_MPC{AT_MPC(MPC_list(i))}.ind_data(:,2));

        otherwise
            fprintf (1, '\nОшибка функции DB_MPC_Delete: неизвестынй тип MPC с номером %i [%s] !\n', MPC_list(i), DB_MPC{AT_MPC(MPC_list(i))}.type);
            ErrCode = -1;
            return;

    end

    if (~isempty(Remove_Nodes_list))
        for j=1:size(Remove_Nodes_list,1)
            AST_NODES{AT_NODES(Remove_Nodes_list(j))}.MPC_list = setdiff(AST_NODES{AT_NODES(Remove_Nodes_list(j))}.MPC_list, MPC_list(i));
            if (isempty(AST_NODES{AT_NODES(Remove_Nodes_list(j))}.MPC_list))
                AST_NODES{AT_NODES(Remove_Nodes_list(j))}.MPC_list = [];
            end
        end
    end

end

% Удаление MPC из базы данных и адресной таблицы
for i=1:size(MPC_list,1)
    
    DB_MPC{AT_MPC(MPC_list(i))}.ID = -1;
    AT_MPC(MPC_list(i)) = 0;

end
